package pnpm

import (
	"testing"

	"github.com/stretchr/testify/require"

	"gitlab.com/gitlab-org/security-products/analyzers/gemnasium/v3/scanner/parser"
	"gitlab.com/gitlab-org/security-products/analyzers/gemnasium/v3/scanner/parser/testutil"
)

func TestPnpm(t *testing.T) {
	t.Run("Parse", func(t *testing.T) {
		t.Run("wrong version", func(t *testing.T) {
			fixture := testutil.Fixture(t, "wrong_versions", "pnpm-lock.yaml")
			_, _, err := Parse(fixture, parser.Options{})
			require.EqualError(t, err, parser.ErrWrongFileFormatVersion.Error())
		})

		tcs := []struct {
			name            string
			fixtureName     string
			expectationName string
			options         parser.Options
		}{
			{
				"v5/simple",
				"v5/simple",
				"v5/simple",
				parser.Options{IncludeDev: true},
			},
			{
				"v5/simple/ignore-dev",
				"v5/simple/ignore-dev",
				"v5/simple/ignore-dev",
				parser.Options{IncludeDev: false},
			},
			{
				"v5/complex",
				"v5/complex",
				"v5/complex",
				parser.Options{IncludeDev: true},
			},
			{
				"v5/tarball",
				"v5/tarball",
				"v5/tarball",
				parser.Options{IncludeDev: true},
			},
			{
				"v6/simple",
				"v6/simple",
				"v6/simple",
				parser.Options{IncludeDev: true},
			},
			// This is a special test case for
			// Lockfile.extractPackageNameAndVersion function
			// were we test the case that a badly formatted
			// package version definition in the lock file
			// should be skipped and should not be listed
			// in packages.json fixture.
			//
			// We have manually mangled up pnpm-lock.yaml to
			// allow for this case as it shouldn't happen when the lockfile
			// gets generated by PNPM itself.
			{
				"bad_pkg_version",
				"bad_pkg_version",
				"bad_pkg_version",
				parser.Options{IncludeDev: true},
			},
		}
		for _, tc := range tcs {
			t.Run(tc.name, func(t *testing.T) {
				fixture := testutil.Fixture(t, tc.fixtureName, "pnpm-lock.yaml")
				got, _, err := Parse(fixture, tc.options)
				require.NoError(t, err)
				testutil.RequireExpectedPackages(t, tc.expectationName, got)
			})
		}
	})
}
